﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace Loot_a_rator
{
	public class Loot_a_rator : HBPlugin
	{
		public override string Name { get { return "Loot-a-rator"; } }

		public override string Author { get { return "p1xel8ted"; } }

		public override string ButtonText { get { return "Settings"; } }

		public override bool WantButton { get { return false; } }

		public override Version Version { get { return new Version(1, 0, 1); } }

		private static LocalPlayer Me { get { return StyxWoW.Me; } }

		private List<uint> lootArangList = new List<uint>(new uint[] {
			109167,	//Findle's Loot-A-Rang
			60854 //Loot-A-Rang (Eng Only)
		});

		private IOrderedEnumerable<WoWUnit> LootableCorpses
		{
			get
			{
				var lootList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(b => b.Lootable && b.Distance <= 25).OrderBy(l => l.Distance);
				return lootList;
			}
		}

		private void Log(string log, bool error)
		{
			if (error)
			{
				Logging.Write(Colors.Red, Name + ": " + Version + "- " + log);
			}
			else
			{
				Logging.Write(Colors.Orange, Name + " " + Version + " - " + log);
			}
		}

		public override void OnEnable()
		{
			Log("Enabled", false);
			BotEvents.OnBotStarted += OnBotStarted;
			BotEvents.OnBotStopped += OnBotStopped;
			base.OnEnable();
		}

		private void OnBotStarted(EventArgs args)
		{
			Log("Beginning Loot-a-rang Process.", false);
		}

		public override void OnDisable()
		{
			Log("Disabled", false);
			BotEvents.OnBotStarted -= OnBotStarted;
			BotEvents.OnBotStopped -= OnBotStopped;
			base.OnDisable();
		}

		private void OnBotStopped(EventArgs args)
		{
			Log("Stopping Loot-a-rang Process.", false);
		}

		private void throwTheBoomerang()
		{
			var lootTarget = LootableCorpses.FirstOrDefault();
			if (getLootArang() != null & lootTarget != null)
			{
				if (lootTarget.Lootable)
				{
					TimeSpan lootCD = new TimeSpan(0);
					if (getLootArang().CooldownTimeLeft <= lootCD)
					{
						Log("Loot Detected! Using " + getLootArang().SafeName + "!", false);
						if (Me.IsMoving)
						{
							Log("** STOP MOVING **", false);
						}
						else
						{
							getLootArang().UseContainerItem();
#pragma warning disable CS0618 // Type or member is obsolete
							StyxWoW.Sleep(3500); //Bot was running to loot instead of using Rang while it was on CD.
#pragma warning restore CS0618 // Type or member is obsolete
						}
					}
				}
			}
		}

		private WoWItem getLootArang()
		{
			foreach (uint i in lootArangList)
			{
				WoWItem lootArang = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == i);
				if (lootArang != null)
				{
					var lootCD = new TimeSpan(0, 0, 0);
					if (lootArang.CooldownTimeLeft <= lootCD)
					{
						return lootArang;
					}
				}
				continue;
			}
			return null;
		}

		private bool IfCapable()
		{
			if (Me.IsMoving || Me.Stunned || Me.IsDead || Me.OnTaxi || Me.IsGhost || Me.IsOnTransport || (Me.Mounted && Me.IsFlying))
			{
				return false;
			}
			else
			{
				return true;
			}
		}

		public override void Pulse()
		{
			if (IfCapable())
			{
				throwTheBoomerang();
			}
		}
	}
}